// Type2.cpp
// Copyright (C) 2019 Katayama Hirofumi MZ <katayama.hirofumi.mz@gmail.com>
// This file is public domain software.
#include <windows.h>
#include <windowsx.h>

TCHAR g_name1[] = TEXT("Type2 W1");
TCHAR g_name2[] = TEXT("Type2 W2");

HWND g_hwndW1 = NULL;
HWND g_hwndW2 = NULL;

void W2_OnDestroy(HWND hwnd)
{
    PostQuitMessage(0);
}

LRESULT CALLBACK
W2WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        HANDLE_MSG(hwnd, WM_DESTROY, W2_OnDestroy);
    default:
        return DefWindowProc(hwnd, uMsg, wParam, lParam);
    }
    return 0;
}

BOOL W1_OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct)
{
    g_hwndW2 = CreateWindowEx(0, g_name2, g_name2, WS_OVERLAPPEDWINDOW,
                              CW_USEDEFAULT, 0, 320, 200, hwnd,
                              NULL, GetModuleHandle(NULL), NULL);
    if (!g_hwndW2)
    {
        MessageBoxA(NULL, "W2 CreateWindow", NULL, MB_ICONERROR);
        return FALSE;
    }

    ShowWindow(g_hwndW2, SW_SHOWNORMAL);
    UpdateWindow(g_hwndW2);

    return TRUE;
}

void W1_OnDestroy(HWND hwnd)
{
    PostQuitMessage(0);
}

LRESULT CALLBACK
W1WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        HANDLE_MSG(hwnd, WM_CREATE, W1_OnCreate);
        HANDLE_MSG(hwnd, WM_DESTROY, W1_OnDestroy);
    default:
        return DefWindowProc(hwnd, uMsg, wParam, lParam);
    }
    return 0;
}

INT WINAPI
WinMain(HINSTANCE   hInstance,
        HINSTANCE   hPrevInstance,
        LPSTR       lpCmdLine,
        INT         nCmdShow)
{
    WNDCLASS wc;
    ZeroMemory(&wc, sizeof(wc));
    wc.lpfnWndProc = W1WindowProc;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_3DFACE + 1);
    wc.lpszClassName = g_name1;
    if (!RegisterClass(&wc))
    {
        MessageBoxA(NULL, "W1 RegisterClass", NULL, MB_ICONERROR);
        return -1;
    }

    wc.lpfnWndProc = W2WindowProc;
    wc.lpszClassName = g_name2;
    if (!RegisterClass(&wc))
    {
        MessageBoxA(NULL, "W2 RegisterClass", NULL, MB_ICONERROR);
        return -2;
    }

    g_hwndW1 = CreateWindowEx(0, g_name1, g_name1, WS_OVERLAPPEDWINDOW,
                              CW_USEDEFAULT, 0, 450, 250,
                              NULL, NULL, hInstance, NULL);
    if (g_hwndW1 == NULL)
    {
        MessageBoxA(NULL, "W1 CreateWindow", NULL, MB_ICONERROR);
        return -3;
    }

    //ShowWindow(g_hwndW1, SW_SHOWNORMAL); // invisible
    UpdateWindow(g_hwndW1);

    MSG msg;
    while (GetMessage(&msg, NULL, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return (INT)msg.wParam;
}
